/**************************************************************
 *
 *  Program Title:  
 *  
 *  Program Name:  External_Converters.h	  Version: 0.01
 *  
 *  Author:  BR	  					  Date:  March 26, 2008
 *  
 *  
 *  This modual provides functions to control the ADS1110 and the DAC8501
 *  These devices are not placed on the WASP by default so they may not be
 *  available to you.  They may however be soldered onto the board if required.
 *
 * Copyright 2008, SOC ROBOTICS, Inc.  All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 *
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 * 3. Neither the name of the copyright holders nor the names of
 *    contributors may be used to endorse or promote products derived
 *    from this software without specific prior written permission.
 * 4. Redistribution is only allowed in combination with SOC ROBOTICS, 
 *    Inc. hardware products.
 *
 * THIS SOFTWARE IS PROVIDED BY SOC ROBOTICS, INC. AND CONTRIBUTORS
 * ``AS IS'' AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
 * LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS
 * FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL SOC ROBOTICS, 
 * INC. OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT,
 * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING,
 * BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS
 * OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED
 * AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY,
 * OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF
 * THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 *
 * For additional information see http://www.soc-robotics.com
 */


//I2C device address of the ADS1110 -> 1001001
#define ADC_ADDRESS 0x49
//Registers of the ADS1110 -> see datasheet for description
#define ST_DRDY 7
#define SC 4
#define DR 2
#define PGA 0

//#define MOSI PB5
//#define SCLK PB7
//will need to ensure that this is an input to ensure the SPI does not become as Slave
//#define SS PB4
//#define SPI_DDR DDRB

//#define DAC_EN_DIR DDRC
//#define DAC_EN_PORT PORTC
//#define DAC_EN PC2

//ADS1110
int InitI2CADC(unsigned char control);
int ReadI2CADC(void);
//DAC8501
void InitDAC(void);
//void ReleaseDAC(void);
void WriteDAC(unsigned int data);




void InitFlash(void);
void Flash(unsigned int data);
