#include "AT91SAM7S32.h"
#include "board.h"
#include "Wasp_Arm_Utilities.h"


static volatile AT91PS_ADC pADC = AT91C_BASE_ADC;// pointer to ADC data structure

int ad[8];

void ADC_Init(void)
{
	//Set up the ADC
	//will have to better work out the values
	pADC->ADC_MR = (AT91C_ADC_SLEEP_MODE |(0x4 <<  8)|(0xd << 16)|(0x3 << 24));

	/*
	 *Enable what channels need to be read
	 */

	pADC->ADC_CHER = AT91C_ADC_CH0;//YOUT
	pADC->ADC_CHER = AT91C_ADC_CH1;//ZOUT
	pADC->ADC_CHER = AT91C_ADC_CH2;//Battery
	pADC->ADC_CHER = AT91C_ADC_CH3;//Temp
	pADC->ADC_CHER = AT91C_ADC_CH4;//Light
	pADC->ADC_CHER = AT91C_ADC_CH5;//XOUT
	pADC->ADC_CHER = AT91C_ADC_CH6;
	pADC->ADC_CHER = AT91C_ADC_CH7;
}

void Read_ADC(void)
{
	pADC->ADC_CR = AT91C_ADC_START;
	while(!(pADC->ADC_SR & AT91C_ADC_EOC7));

	ad[0] = (pADC->ADC_CDR0 & AT91C_ADC_DATA);
	ad[1] = (pADC->ADC_CDR1 & AT91C_ADC_DATA);
	ad[2] = (pADC->ADC_CDR2 & AT91C_ADC_DATA);
	ad[3] = (pADC->ADC_CDR3 & AT91C_ADC_DATA);
	ad[4] = (pADC->ADC_CDR4 & AT91C_ADC_DATA);
	ad[5] = (pADC->ADC_CDR5 & AT91C_ADC_DATA);
	ad[6] = (pADC->ADC_CDR6 & AT91C_ADC_DATA);
	ad[7] = (pADC->ADC_CDR7 & AT91C_ADC_DATA);
}


unsigned char *Print_Int(int intvalue, unsigned char *text, int base)
{
	 char myLetters[] = {'0','1','2','3','4','5','6','7','8','9','A','B','C','D','E','F'};
	 int start=0, count = 0;
	 unsigned char temp;

	 if (base == DEC)
	 {
		 if(intvalue < 0)
		 {
			text[count++] = '-';
			intvalue = -intvalue;
			start++;
		 }
	 }else if (base == HEX)
	 {
		text[count++] = '0';
		text[count++] = 'x';
		start+=2;
	 } else if (base == OCT)
	 {
		text[count++] = '0';
		text[count++] = 'O';
		start+=2;
	 } else if (base == BIN)
	 {
		text[count++] = '0';
		text[count++] = 'B';
		start+=2;
	 }

	 //find the digits
	 do {
	 	text[count++] = myLetters[intvalue % base];
	 } while ((intvalue /= base) > 0);

	 text[count--] = 0x00;

	 //reverse to correct order
	 while (start < count)
	 {
		 temp = text[start];
		 text[start] = text[count];
		 text[count] = temp;
		 start++;
		 count--;
	 }

	 return text;
}
